<div class="container">
  <div class="row mt-4">
    <div class="col text-center">
      <h3>Métricas de produtos do portal Molekada</h3>
    </div>
  </div>
</div>

<div class="text-left">
  Última atualização: {{updated}}
</div>

<p-tabView [(activeIndex)]="activeIndex" (onChange)="changeTab()">
  <p-tabPanel header="Produtos">
    <div class="row">
      <div class="col-12">
        <span class="p-input-icon-left search-field">
          <i class="pi pi-search"></i>
          <input pInputText type="text" name="fitler" [(ngModel)]="filter" style="width: 100%;"
            placeholder="Digite o código do produto..." (ngModelChange)="filterList()" />
        </span>
        <p-autoComplete [(ngModel)]="selectedCategory" [suggestions]="categories" (completeMethod)="listCategories()"
          (onSelect)="filterList()" (onUnselect)="filterList()" (onClear)="filterList()" [dropdown]="true"
          field="categoria_nome"></p-autoComplete>

        <button pButton *ngIf="showButtonFilter" type="button" style="margin-left: 5px; margin-bottom: 10px !important;" label="Limpar Filtros"
          class="p-button-success" (click)="clearFilter();"></button>
          <button *ngIf="!exporting; else buttonLoading" pButton type="button" style="margin-left: 5px; margin-bottom: 10px !important;" label="Exportar Dados"
             (click)="export();"></button>
          <ng-template #buttonLoading>
            <button pButton type="button" style="margin-left: 5px; margin-bottom: 10px !important;" label="Exportando...">
            </button>
          </ng-template>

      </div>
    </div>

    <p-table *ngIf="produtos$ | async as produtos; else loadingError" [columns]="colsCadCom" #dt
      [value]="produtos.contents" responsiveLayout="scroll" selectionMode="single" dataKey="codigo"
      (sortFunction)="sortList($event)" [customSort]="true">
      <ng-template pTemplate="header" let-columns>
        <tr>
          <th pSortableColumn="codigo">Código <p-sortIcon field="codigo"></p-sortIcon></th>
          <th pSortableColumn="name">Produto <p-sortIcon field="name"></p-sortIcon></th>
          <th>Preço médio</th>
          <th pSortableColumn="percentual_lucro">Percentual de lucro <p-sortIcon field="percentual_lucro"></p-sortIcon>
          </th>
          <th>Markup</th>
          <th>Custo</th>
          <th pSortableColumn="categoria_nome">Categoria <p-sortIcon field="categoria_nome"></p-sortIcon></th>
          <th pSortableColumn="itens_vendidos">Itens Vendidos <p-sortIcon field="itens_vendidos"></p-sortIcon></th>
        </tr>
      </ng-template>
      <ng-template pTemplate="body" let-rowData let-columns>
        <tr [pSelectableRow]="rowData">
          <td>{{columns.codigo}}</td>
          <td>{{columns.name}}</td>
          <td>{{columns.preco_media | currency: 'BRL'}}</td>
          <td>{{columns.percentual_lucro | number : '1.2-2'}}%</td>
          <td>{{columns.markup | number : '1.2-2'}}</td>
          <td>{{columns.custo | currency: 'BRL'}}</td>
          <td>{{columns.categoria_nome}}</td>
          <td>{{columns.itens_vendidos}}</td>
        </tr>
      </ng-template>
    </p-table>
    <p-paginator [rows]="tableRows" [totalRecords]="totalElements" (onPageChange)="paginate($event)"></p-paginator>

    <ng-template #loadingError>
      <div *ngIf="error$ | async; else loading">
        Erro ao carregar Produtos. Tente novamente mais tarde.
      </div>
      <ng-template #loading>
        <span>Carregando Produtos...</span>
      </ng-template>
    </ng-template>
  </p-tabPanel>
  <p-tabPanel header="Produtos agrupados por código">
    <div class="row">
      <div class="col">
        <span class="p-input-icon-left search-field">
          <i class="pi pi-search"></i>
          <input pInputText type="text" name="fitlerAgrupados" [(ngModel)]="filterAgrupados" style="width: 100%;"
            placeholder="Digite o código do produto..." (ngModelChange)="filterListAgrupados()" />
        </span>
        <p-autoComplete [(ngModel)]="selectedCategory" [suggestions]="categories" (completeMethod)="listCategories()"
          (onSelect)="filterListAgrupados()" (onUnselect)="filterListAgrupados()" (onClear)="filterListAgrupados()" [dropdown]="true"
          field="categoria_nome"></p-autoComplete>

        <button pButton pRipple type="button" style="margin-left: 5px; margin-bottom: 10px !important;" label="Limpar Filtros"
          class="p-button-success" (click)="clearFilterAgrupados();"></button>
          <button *ngIf="!exporting; else buttonLoading" pButton type="button"
            style="margin-left: 5px; margin-bottom: 10px !important;" label="Exportar Dados" (click)="export();"></button>
          <ng-template #buttonLoading>
            <button pButton type="button" style="margin-left: 5px; margin-bottom: 10px !important;" label="Exportando...">
            </button>
          </ng-template>
      </div>
    </div>

    <p-table *ngIf="produtosAgrupados$ | async as produtosAgrupados; else loadingErrorAgrupados"
      [columns]="colsCadComAgrupados" #dt [value]="produtosAgrupados.contents" responsiveLayout="scroll"
      selectionMode="single" dataKey="codigo" (sortFunction)="sortListAgrupados($event)" [customSort]="true">
      <ng-template pTemplate="header" let-columns>
        <tr>
          <th pSortableColumn="codigo">Código <p-sortIcon field="codigo"></p-sortIcon></th>
          <th pSortableColumn="name">Produto <p-sortIcon field="name"></p-sortIcon></th>
          <th>Preço médio</th>
          <th pSortableColumn="percentual_lucro">Percentual de lucro <p-sortIcon field="percentual_lucro"></p-sortIcon>
          </th>
          <th>Markup</th>
          <th>Custo</th>
          <th pSortableColumn="itens_vendidos">Itens Vendidos <p-sortIcon field="itens_vendidos"></p-sortIcon></th>
        </tr>
      </ng-template>
      <ng-template pTemplate="body" let-rowData let-columns>
        <tr [pSelectableRow]="rowData">
          <td>{{columns.codigo}}</td>
          <td>{{columns.name}}</td>
          <td>{{columns.preco_media | currency: 'BRL'}}</td>
          <td>{{columns.percentual_lucro | number : '1.2-2'}}%</td>
          <td>{{columns.markup | number : '1.2-2'}}</td>
          <td>{{columns.custo | currency: 'BRL'}}</td>
          <td>{{columns.itens_vendidos}}</td>
        </tr>
      </ng-template>
    </p-table>
    <p-paginator [rows]="tableRowsAgrupados" [totalRecords]="totalElementsAgrupados"
      (onPageChange)="paginateAgrupados($event)"></p-paginator>

    <ng-template #loadingErrorAgrupados>
      <div *ngIf="errorAgrupados$ | async; else loadingAgrupados">
        Erro ao carregar Produtos. Tente novamente mais tarde.
      </div>
      <ng-template #loadingAgrupados>
        <span>Carregando Produtos...</span>
      </ng-template>
    </ng-template>
  </p-tabPanel>

  <!-- ############# Produtos New ############### -->
  <p-tabPanel header="Produtos New">
    <!-- ############# Filtros ############### -->
    <div class="row">
        <div class="col-md-10">
          <span class="p-input-icon-left search-field">
            <i class="pi pi-search"></i>
            <input pInputText type="text" name="fitler" [(ngModel)]="filter" style="width: 100%;"
              placeholder="Digite o código do produto..." (ngModelChange)="filterListNew()" />
          </span>
          <p-autoComplete [(ngModel)]="selectedCategory" [suggestions]="categories" (completeMethod)="listCategories()"
            (onSelect)="filterListNew()" (onUnselect)="filterListNew()" (onClear)="filterListNew()" [dropdown]="true"
            field="categoria_nome" placeholder="Filtrar por categoria" style="margin-right: 7px;"></p-autoComplete>
          <p-autoComplete [(ngModel)]="selectedFilter" [suggestions]="lojas" (completeMethod)="filterListNew()"
            (onSelect)="filterListNew()" [dropdown]="true"field="nome" placeholder="Filtrar por loja" style="margin-right: 7px;"></p-autoComplete>
            <p-autoComplete [(ngModel)]="selectedMarketplace" [suggestions]="marketplaces" (completeMethod)="listMarketplaces()"
              (onSelect)="filterListNew()" [dropdown]="true" field="marketplace_nome" placeholder="Filtrar por Marketplace" ></p-autoComplete>
        </div>

        <div class="col-md-2 flex justify-content-end" style="padding-right: 30px;">
            <span class="flex flex-column gap-2">
              <p-calendar dateFormat="dd/mm/yy" [(ngModel)]="rangeData" [showIcon]="true" id="inicio" (onClose)="filterListNew()"
              selectionMode="range" [readonlyInput]="true"></p-calendar>
              <label>Selecione a data</label>
            </span>
        </div>
    </div>
    <!-- ############# Botões ############### -->
    <div class="col-12">
      <button pButton pRipple type="button" style="margin-left: 5px; margin-bottom: 10px !important;" label="Limpar Filtros"
        class="p-button-success" (click)="clearFilter(true);"></button>
      <button *ngIf="!exporting; else buttonLoading" pButton type="button"
        style="margin-left: 5px; margin-bottom: 10px !important;" label="Exportar Dados" (click)="export();"></button>
      <ng-template #buttonLoading>
        <button pButton type="button" style="margin-left: 5px; margin-bottom: 10px !important;" label="Exportando...">
        </button>
      </ng-template>
    </div>

    <!-- ############# Tabela ############### -->
    <p-table *ngIf="produtosNew$ | async as produtos; else loadingError" [columns]="colsCadCom" #dt [value]="produtos.contents"
      responsiveLayout="scroll" selectionMode="single" dataKey="codigo" (sortFunction)="sortListNew($event)"
      [customSort]="true">
      <ng-template pTemplate="header" let-columns>
        <tr>
          <th pSortableColumn="codigo">Código <p-sortIcon field="codigo"></p-sortIcon></th>
          <th pSortableColumn="name">Produto <p-sortIcon field="name"></p-sortIcon></th>
          <th>Preço médio</th>
          <th pSortableColumn="percentual_lucro">Percentual de lucro <p-sortIcon field="percentual_lucro"></p-sortIcon>
          </th>
          <th>Markup</th>
          <th>Custo</th>
          <th pSortableColumn="categoria_nome">Categoria <p-sortIcon field="categoria_nome"></p-sortIcon></th>
          <th pSortableColumn="itens_vendidos">Itens Vendidos <p-sortIcon field="itens_vendidos"></p-sortIcon></th>
        </tr>
      </ng-template>
      <ng-template pTemplate="body" let-rowData let-columns>
        <tr [pSelectableRow]="rowData">
          <td>{{columns.codigo}}</td>
          <td>{{columns.name}}</td>
          <td>{{columns.preco_media | currency: 'BRL'}}</td>
          <td>{{columns.percentual_lucro | number : '1.2-2'}}%</td>
          <td>{{columns.markup | number : '1.2-2'}}</td>
          <td>{{columns.custo | currency: 'BRL'}}</td>
          <td>{{columns.categoria_nome}}</td>
          <td>{{columns.itens_vendidos}}</td>
        </tr>
      </ng-template>
    </p-table>
    <p-paginator [rows]="tableRows" [totalRecords]="totalElementsNew" (onPageChange)="paginateNew($event)"></p-paginator>

    <ng-template #loadingError>
      <div *ngIf="error$ | async; else loading">
        Erro ao carregar Produtos. Tente novamente mais tarde.
      </div>
      <ng-template #loading>
        <span>Carregando Produtos...</span>
      </ng-template>
    </ng-template>
  </p-tabPanel>

  <!-- ############# Produtos agrupados por código new ############### -->
  <p-tabPanel header="Produtos agrupados por código New">
    <!-- ############# Filtros ############### -->
    <div class="row">
      <div class="col-md-10">
        <span class="p-input-icon-left search-field">
          <i class="pi pi-search"></i>
          <input pInputText type="text" name="fitler" [(ngModel)]="filter" style="width: 100%;"
            placeholder="Digite o código do produto..." (ngModelChange)="filterListNew()" />
        </span>
        <p-autoComplete [(ngModel)]="selectedCategory" [suggestions]="categories" (completeMethod)="listCategories()"
          (onSelect)="filterListNew()" (onUnselect)="filterListNew()" (onClear)="filterListNew()" [dropdown]="true"
          field="categoria_nome" placeholder="Filtrar por categoria" style="margin-right: 7px;"></p-autoComplete>
        <p-autoComplete [(ngModel)]="selectedFilter" [suggestions]="lojas" (completeMethod)="filterListNew()"
          (onSelect)="filterListNew()" [dropdown]="true" field="nome" placeholder="Filtrar por loja" style="margin-right: 7px;"></p-autoComplete>
            <p-autoComplete [(ngModel)]="selectedMarketplace" [suggestions]="marketplaces" (completeMethod)="listMarketplaces()"
              (onSelect)="filterListNew()" [dropdown]="true" field="marketplace_nome" placeholder="Filtrar por Marketplace"></p-autoComplete>
      </div>

      <div class="col-md-2 flex justify-content-end" style="padding-right: 30px;">
        <span class="flex flex-column gap-2">
          <p-calendar dateFormat="dd/mm/yy" [(ngModel)]="rangeData" [showIcon]="true" id="inicio"
            (onClose)="filterListNew()" selectionMode="range" [readonlyInput]="true"></p-calendar>
          <label>Selecione a data</label>
        </span>
      </div>
    </div>
    <!-- ############# Botões ############### -->
    <div class="col-12">
      <button pButton pRipple type="button" style="margin-left: 5px; margin-bottom: 10px !important;"
        label="Limpar Filtros" class="p-button-success" (click)="clearFilter(true);"></button>
      <button *ngIf="!exporting; else buttonLoading" pButton type="button"
        style="margin-left: 5px; margin-bottom: 10px !important;" label="Exportar Dados" (click)="export();"></button>
      <ng-template #buttonLoading>
        <button pButton type="button" style="margin-left: 5px; margin-bottom: 10px !important;" label="Exportando...">
        </button>
      </ng-template>
    </div>

    <!-- ############# Tabela ############### -->
    <p-table *ngIf="produtosNew$ | async as produtos; else loadingError" [columns]="colsCadCom" #dt
      [value]="produtos.contents" responsiveLayout="scroll" selectionMode="single" dataKey="codigo"
      (sortFunction)="sortListNew($event)" [customSort]="true">
      <ng-template pTemplate="header" let-columns>
        <tr>
          <th pSortableColumn="codigo">Código <p-sortIcon field="codigo"></p-sortIcon></th>
          <th pSortableColumn="name">Produto <p-sortIcon field="name"></p-sortIcon></th>
          <th>Preço médio</th>
          <th pSortableColumn="percentual_lucro">Percentual de lucro <p-sortIcon field="percentual_lucro"></p-sortIcon>
          </th>
          <th>Markup</th>
          <th>Custo</th>
          <th pSortableColumn="itens_vendidos">Itens Vendidos <p-sortIcon field="itens_vendidos"></p-sortIcon></th>
        </tr>
      </ng-template>
      <ng-template pTemplate="body" let-rowData let-columns>
        <tr [pSelectableRow]="rowData">
          <td>{{columns.codigo}}</td>
          <td>{{columns.name}}</td>
          <td>{{columns.preco_media | currency: 'BRL'}}</td>
          <td>{{columns.percentual_lucro | number : '1.2-2'}}%</td>
          <td>{{columns.markup | number : '1.2-2'}}</td>
          <td>{{columns.custo | currency: 'BRL'}}</td>
          <td>{{columns.itens_vendidos}}</td>
        </tr>
      </ng-template>
    </p-table>
    <p-paginator [rows]="tableRows" [totalRecords]="totalElementsNew" (onPageChange)="paginateNew($event)"></p-paginator>

    <ng-template #loadingError>
      <div *ngIf="error$ | async; else loading">
        Erro ao carregar Produtos. Tente novamente mais tarde.
      </div>
      <ng-template #loading>
        <span>Carregando Produtos...</span>
      </ng-template>
    </ng-template>
  </p-tabPanel>
</p-tabView>
